From a1bf6ea80c3e5baf6b72fd75948b4864974062c1 Mon Sep 17 00:00:00 2001
From: Holger Just <hjust@meine-er.de>
Date: Sat, 25 Aug 2012 12:10:14 +0200
Subject: Port async delivery methods to Rails 3

Original code by Jean-Philippe Lang
redmine:b590ff105e2e69ccd5b06c2783860e78bc1b392b

--HG--
extra : source : b71bded272222960962ee6e49ec398260fa3ad63
---
 config/initializers/10-patches.rb |   22 +++++++++++++++-------
 1 files changed, 15 insertions(+), 7 deletions(-)

diff --git a/config/initializers/10-patches.rb b/config/initializers/10-patches.rb
index 324f518..e0b9ebb 100644
--- a/config/initializers/10-patches.rb
+++ b/config/initializers/10-patches.rb
@@ -125,19 +125,27 @@ end
 
 ActionView::Base.field_error_proc = Proc.new{ |html_tag, instance| "#{html_tag}" }
 
-# Adds :async_smtp and :async_sendmail delivery methods
-# to perform email deliveries asynchronously
-module AsynchronousMailer
-  %w(smtp sendmail).each do |type|
-    define_method("perform_delivery_async_#{type}") do |mail|
+require 'mail'
+module DeliveryMethods
+  class AsyncSMTP < ::Mail::SMTP
+    def deliver!(*args)
       Thread.start do
-        send "perform_delivery_#{type}", mail
+        super *args
+      end
+    end
+  end
+
+  class AsyncSendmail < ::Mail::Sendmail
+    def deliver!(*args)
+      Thread.start do
+        super *args
       end
     end
   end
 end
 
-ActionMailer::Base.send :include, AsynchronousMailer
+ActionMailer::Base.add_delivery_method :async_smtp, DeliveryMethods::AsyncSMTP
+ActionMailer::Base.add_delivery_method :async_sendmail, DeliveryMethods::AsyncSendmail
 
 module ActionController
   module MimeResponds
-- 
1.7.1


